#include <stdio.h>
#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif
#ifdef HAVE_SYS_PARAM_H
# include <sys/param.h>
#endif
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* if we don't have MAXPATHLEN, it might be calles PATH_MAX.  Failing *
 * that, we pick a reasonable default.                                */
#ifndef MAXPATHLEN
# ifdef PATH_MAX
#  define MAXPATHLEN PATH_MAX
# else
#  define MAXPATHLEN 1024
# endif
#endif

/* getwd() is preferred here, even though getcwd() is the POSIX *
 * function.  This is because getcwd() on SunOS actually uses   *
 * popen(), and runs /bin/sh -c pwd.  I've not seen a getwd()   *
 * implementation with this problem.                            */

int main()
{
  static char buffer[MAXPATHLEN+1], *ret;
#ifdef HAVE_GETWD
  ret=getwd(buffer);
#else
  ret=getcwd(buffer, MAXPATHLEN);
#endif
  if(!ret) {
    perror("pwd");
    exit(1);
  }
  puts(ret);
  exit(0);
}
